<#

This script will open a connection to SQL run a query and the close a connection.  Then it will loop and do the same thing over again. 
The output will be placed in a log file ($logLoaction).

You will want to change the variables below: 

$serverName="Your server name"
$databaseName="The name of your database"
$uid="User ID"
$pwd="user Password "
$sqlCommand="A simple select statement like  ---   select count(*) from ITEM"
$logLoaction="This is where you want your log file to write out to.   ---  c:\ps\OpenConnQueryCloseConn.log"


How to call this script.
PowerShell.exe -ExecutionPolicy Bypass -File C:\PS\OpenConnQueryCloseConn.ps1

#>

#change the variables below
$serverName="TSMSQLTEST"
$databaseName="TESTDB"
$uid="john"
$pwd="passwordJOHN"
$sqlCommand="select count(*) from HISTORY"
$logLoaction="c:\ps\OpenConnQueryCloseConn.log"


function fn_HitSQL
{
  #This line is for Integrated Security if you want it.
#$cn2 = new-object system.data.SqlClient.SQLConnection("Data Source=$serverName;Integrated Security=True;Connect Timeout=10 ;Initial Catalog=$databaseName");
$cn = new-object system.data.SqlClient.SQLConnection("Data Source=$serverName;User ID=$uid;Password=$pwd;Connect Timeout=10 ;Initial Catalog=$databaseName");
$cmd = new-object system.data.sqlclient.sqlcommand($sqlCommand, $cn);
$cmd.CommandTimeout=20;
    try
    {
    # Open connection.
    $cn.Open(); 


    fn_WriteToLog "Connecting to server and database opened .";
    }
    catch 
    {   #Catch the error on the open connection.
        echo  $_.Exception.Message;
        fn_WriteToLog "ERROR opening connection. $_.Exception.Message";
        return;
    };

    try
    {   # Execute the Query
    	if ($cmd.ExecuteNonQuery() -ne -1)
    	{
    		fn_WriteToLog "Failed running the query."
       	} else
    	{
    		fn_WriteToLog "SQL command ran."
    	}
    }
    catch [Exception]
    {   #Catch the error on the execute.
        echo  $_.Exception.Message;
        fn_WriteToLog "Error running query. $_.Exception.Message";
        return;
    };
    $cn.Close();

};

#--END function -fn_HitSQL-----------------------------------------------


#----Write log information to a file.----------------------------------------------
function fn_WriteToLog ($pssMessage)
{

   echo $pssMessage
  "$(Get-Date -format 'yyyy-MM-dd HH:mm:ss') $pssMessage" | Add-Content $logLoaction
   return;

};
#--END function -fn_WriteToLog--------------------------------------------

#---------------------------------------------------------------
#  
#  Starting Loop
#  The code below will call the functions above and loop forever on the connection.
#  
#--------------------------------------------------------------

$a = 2 
DO

{
 
 $a
 $a++
# Call main function 
fn_HitSQL;

# Change the line below to change the delay between the time the 
# connection and query is executed.  10 = a 10 seconds delay    
Start-Sleep -s 10

} 
until ($a -eq 1)




